/*
  18-09-2019 ne rabotaet !
  static - TIM234_Config() kakogo-to xera potrebovalsya,
  xotya ran'she i tak krytilas'.

--446re
  0xFF = 90 MHz / 256 = 351.5 ksps
  0x07 = 90 MHz / (7+1)  =  11.5 msps _MAX 
  
*/
    /**TIM GPIO Configuration    
    PB8     ------> TIM2_CH1 D.15 
    PA.4  --------> Dac CH-1 AN.2
      
    PB9     ------> TIM4_CH4 D.14 
    PA.5  --------> Dac CH-2 D.13  
    */

/*    
  Выключить быфера ЦАП-ов, ТЧД высокий от них.

  Bit field starts: 17
  Bit field length: 1
  Reg: 40007400 Value:  0000 0000    0010 1101    0011 0000    0010 0101      (0x002D3025)
  new Value:  0000 0000    0010 1111    0011 0000    0010 0101      (0x002F3025)

  Bit field starts: 1
  Reg: 40007400 Value:  0000 0000    0010 1111    0011 0000    0010 0101      (0x002F3025)
  new Value:  0000 0000    0010 1111    0011 0000    0010 0111      (0x002F3027)
*/

         DAC_HandleTypeDef             DacHandle;

#define  BUF_SIZE               ((uint32_t)  2048)   
        
         uint32_t     buff[BUF_SIZE]    =   { 0};
         
         String       in_String         =     "";        
         boolean      end_input         =  false;  
         uint32_t     adres_reg     = 0x4000002c;         
         uint8_t      debug_osm         =      0;

         uint32_t     adres_bas         =      0;         
         uint32_t     field_bit         =      0;
         uint32_t     field_len         =     16;

         uint16_t     offset_tt         =      0;

  volatile  uint32_t temp;
            uint32_t addr;

          uint16_t        magnt_gen         = 2047;          
          uint16_t        dac_freq1         =    1;          
 
void setup()
{
  Serial.begin(115200);
  in_String.reserve(200);
  Serial.print(F("\n\tSketch:  dac-dma-G474-4d 09-06-2020"));

  generator(dac_freq1, magnt_gen);

  Serial.print(F("\n\tSys_clock: "));
  Serial.print((uint32_t) SystemCoreClock, DEC);

  cfg_Pins(); // debug
  Serial.print(F("\n\tcfg_Pins."));
  delay(100);      

  DacHandle.Instance = DAC;

  TIM2_Config();  
  TIM4_Config();  
  TIM3_Config();
    
  Serial.print(F("\n\tdma_config:"));
  delay(100);      
  DMA_Config(&DacHandle);
  Serial.print(F("\n\tdac_config:"));
  delay(100);      
  DAC_Config();

  __HAL_DMA_DISABLE_IT(DacHandle.DMA_Handle1, DMA_IT_HT);
}

void loop()
{
  uint32_t  temp = 0;
  char *   pEnd;
  
  if(debug_osm) {
    }

// d, a, r, w
// b - adres + base
// f, s - bit field, size
// o -offset Tim-2 & Tim-4
// g. m

  serialEvent(); 

  if( end_input) {
    char cmd = in_String[0];
    in_String[0] = '+';
    
    if( cmd == 'd' ) {
      debug_osm = 1 - debug_osm;
      if(debug_osm) Serial.print(F("\nDebug aktiv."));
      else          Serial.print(F("\nDebug de-aktiv."));
      }
 
    if( cmd == 'g' ) {
      dac_freq1 = strtol( in_String.c_str(), &pEnd, 10);
      generator(dac_freq1, magnt_gen);
      Serial.print(F("\n\tFrequency 1 is set: "));
      Serial.print(dac_freq1, DEC);
      }      
    
    if( cmd == 'm' ) {
      magnt_gen = strtol( in_String.c_str(), &pEnd, 10);
      generator(dac_freq1, magnt_gen);
      Serial.print(F("\n\tAmplitude is set: "));
      Serial.print(magnt_gen, DEC);
      }      
    
    if ( cmd == 'o' ) {
      offset_tt = strtol( in_String.c_str(), &pEnd, 10);
      Serial.print(F("\n\tTT offset: "));
      Serial.print(offset_tt, DEC);
      delay(200);
      
      TIM3->CR1 &= ~(TIM_CR1_CEN);

            addr = 0x40000024;
      (*(uint32_t*)addr) =         0; // reset cntr tim-2

            addr = 0x40000824;
      (*(uint32_t*)addr) = offset_tt; // pre-set cntr tim-4
            
      TIM3->CR1 |=  (TIM_CR1_CEN);
      }

    if( cmd == 'f' ) {
      field_bit = strtol( in_String.c_str(), &pEnd, 10);
      if(field_bit < 32) {
        Serial.print(F("\n\tBit field starts: "));
        Serial.print(field_bit, DEC);        
        }
      else
        Serial.print(F("\n\tError."));
      }
    if( cmd == 's' ) {
      field_len = strtol( in_String.c_str(), &pEnd, 10);
      if((field_len + field_bit) < 32) {
        Serial.print(F("\n\tBit field length: "));
        Serial.print(field_len, DEC);        
        }
      else
        Serial.print(F("\n\tError."));
      }
        
    if( cmd == 'b' ) {
      adres_bas = strtol( in_String.c_str(), &pEnd, 16);
      adres_reg &= 0xFFFFFF00;
      adres_reg |= adres_bas;
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }

    if( cmd == 'a' ) {
      adres_reg = strtol( in_String.c_str(), &pEnd, 16);
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
    if( cmd == 'r' ) {
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
    if( cmd == 'w' ) {
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      
      temp = strtol( in_String.c_str(), &pEnd, 2);      
//      (*(uint32_t*)adres_reg) = temp;
      set_bitf(temp);
  
      Serial.print(F("\tnew Value: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
                
    in_String = "";
    end_input= false;
  }
}

void serialEvent() {
  while (Serial.available()) {
    char inChar = (char)Serial.read();
    in_String += inChar;
    if (inChar == '\n') {
      end_input= true;
    }
  }
}
