/*
    RAM  (xrw) : ORIGIN = 0x20000000,  LENGTH = 128K
    FLASH (rx)  : ORIGIN = 0x8000000, LENGTH = 512K

G4: Base address: 0x1FFF 7590 (96 bits)
Flash_sz address: 0x1FFF 75E0 (16 bits)

  Reg: 1FFF7500 Value:  1111 1111    1111 1111    1111 1111    0000 0000      (0xFFFFFF00)

  Reg: 1FFF7590 Value:  0000 0000    0010 1010    0000 0000    0101 0000      (0x002A0050)
  Reg: 1FFF7594 Value:  0011 0001    0011 0110    0101 0000    0000 0100      (0x31365004)
  Reg: 1FFF7598 Value:  0010 0000    0011 0110    0011 1000    0100 1101      (0x2036384D)

  Reg: 1FFF75E0 Value:  1111 1111    1111 1111    0000 0010    0000 0000      (0xFFFF0200)

#define PACKAGE_BASE          (0x1FFF7500UL)        < Package data register base address     
#define UID_BASE              (0x1FFF7590UL)        < Unique device ID register base address 
#define FLASHSIZE_BASE        (0x1FFF75E0UL)        < Flash size data register base address  
*/
/*
#define FLASH_BASE            (0x08000000UL) < FLASH (up to 512 kB) base address 
#define SRAM1_BASE            (0x20000000UL) < SRAM1(up to 80 KB) base address 
#define SRAM2_BASE            (0x20014000UL) < SRAM2(16 KB) base address 
#define CCMSRAM_BASE          (0x10000000UL) < CCMSRAM(32 KB) base address 

#define SRAM1_BB_BASE         (0x22000000UL) < SRAM1(80 KB) base address in the bit-band region 
#define SRAM2_BB_BASE         (0x22280000UL) < SRAM2(16 KB) base address in the bit-band region 
#define CCMSRAM_BB_BASE       (0x22300000UL) < CCMSRAM(32 KB) base address in the bit-band region 
#define PERIPH_BB_BASE        (0x42000000UL) < Peripheral base address in the bit-band region 

#define SRAM_BASE             SRAM1_BASE
#define SRAM_BB_BASE          SRAM1_BB_BASE

#define SRAM1_SIZE_MAX        (0x00014000UL) < maximum SRAM1 size (up to 80 KBytes) 
#define SRAM2_SIZE            (0x00004000UL) < SRAM2 size (16 KBytes) 
#define CCMSRAM_SIZE          (0x00008000UL) < CCMSRAM size (32 KBytes) 

< Peripheral memory map 
#define PERIPH_BASE           (0x40000000UL) < Peripheral base address 
#define APB1PERIPH_BASE        PERIPH_BASE
#define APB2PERIPH_BASE       (PERIPH_BASE + 0x00010000UL)
#define AHB1PERIPH_BASE       (PERIPH_BASE + 0x00020000UL)
#define AHB2PERIPH_BASE       (PERIPH_BASE + 0x08000000UL)

< APB1 peripherals 
#define TIM2_BASE             (APB1PERIPH_BASE + 0x0000UL)
#define TIM3_BASE             (APB1PERIPH_BASE + 0x0400UL)
#define TIM4_BASE             (APB1PERIPH_BASE + 0x0800UL)
#define TIM5_BASE             (APB1PERIPH_BASE + 0x0C00UL)
#define TIM6_BASE             (APB1PERIPH_BASE + 0x1000UL)
#define TIM7_BASE             (APB1PERIPH_BASE + 0x1400UL)
#define CRS_BASE              (APB1PERIPH_BASE + 0x2000UL)
#define TAMP_BASE             (APB1PERIPH_BASE + 0x2400UL)
#define RTC_BASE              (APB1PERIPH_BASE + 0x2800UL)
#define WWDG_BASE             (APB1PERIPH_BASE + 0x2C00UL)
#define IWDG_BASE             (APB1PERIPH_BASE + 0x3000UL)
#define SPI2_BASE             (APB1PERIPH_BASE + 0x3800UL)
#define SPI3_BASE             (APB1PERIPH_BASE + 0x3C00UL)
#define USART2_BASE           (APB1PERIPH_BASE + 0x4400UL)
#define USART3_BASE           (APB1PERIPH_BASE + 0x4800UL)
#define UART4_BASE            (APB1PERIPH_BASE + 0x4C00UL)
#define UART5_BASE            (APB1PERIPH_BASE + 0x5000UL)
#define I2C1_BASE             (APB1PERIPH_BASE + 0x5400UL)
#define I2C2_BASE             (APB1PERIPH_BASE + 0x5800UL)
#define USB_BASE              (APB1PERIPH_BASE + 0x5C00UL)  < USB_IP Peripheral Registers base address 
#define USB_PMAADDR           (APB1PERIPH_BASE + 0x6000UL)  < USB_IP Packet Memory Area base address 
#define FDCAN1_BASE           (APB1PERIPH_BASE + 0x6400UL)
#define FDCAN_CONFIG_BASE     (APB1PERIPH_BASE + 0x6500UL)  < FDCAN configuration registers base address 
#define FDCAN2_BASE           (APB1PERIPH_BASE + 0x6800UL)
#define FDCAN3_BASE           (APB1PERIPH_BASE + 0x6C00UL)
#define PWR_BASE              (APB1PERIPH_BASE + 0x7000UL)
#define I2C3_BASE             (APB1PERIPH_BASE + 0x7800UL)
#define LPTIM1_BASE           (APB1PERIPH_BASE + 0x7C00UL)
#define LPUART1_BASE          (APB1PERIPH_BASE + 0x8000UL)
#define I2C4_BASE             (APB1PERIPH_BASE + 0x8400UL)
#define UCPD1_BASE            (APB1PERIPH_BASE + 0xA000UL)
#define SRAMCAN_BASE          (APB1PERIPH_BASE + 0xA400UL)

< APB2 peripherals 
#define SYSCFG_BASE           (APB2PERIPH_BASE + 0x0000UL)
#define VREFBUF_BASE          (APB2PERIPH_BASE + 0x0030UL)
#define COMP1_BASE            (APB2PERIPH_BASE + 0x0200UL)
#define COMP2_BASE            (APB2PERIPH_BASE + 0x0204UL)
#define COMP3_BASE            (APB2PERIPH_BASE + 0x0208UL)
#define COMP4_BASE            (APB2PERIPH_BASE + 0x020CUL)
#define COMP5_BASE            (APB2PERIPH_BASE + 0x0210UL)
#define COMP6_BASE            (APB2PERIPH_BASE + 0x0214UL)
#define COMP7_BASE            (APB2PERIPH_BASE + 0x0218UL)
#define OPAMP_BASE            (APB2PERIPH_BASE + 0x0300UL)
#define OPAMP1_BASE           (APB2PERIPH_BASE + 0x0300UL)
#define OPAMP2_BASE           (APB2PERIPH_BASE + 0x0304UL)
#define OPAMP3_BASE           (APB2PERIPH_BASE + 0x0308UL)
#define OPAMP4_BASE           (APB2PERIPH_BASE + 0x030CUL)
#define OPAMP5_BASE           (APB2PERIPH_BASE + 0x0310UL)
#define OPAMP6_BASE           (APB2PERIPH_BASE + 0x0314UL)

#define EXTI_BASE             (APB2PERIPH_BASE + 0x0400UL)
#define TIM1_BASE             (APB2PERIPH_BASE + 0x2C00UL)
#define SPI1_BASE             (APB2PERIPH_BASE + 0x3000UL)
#define TIM8_BASE             (APB2PERIPH_BASE + 0x3400UL)
#define USART1_BASE           (APB2PERIPH_BASE + 0x3800UL)
#define SPI4_BASE             (APB2PERIPH_BASE + 0x3C00UL)
#define TIM15_BASE            (APB2PERIPH_BASE + 0x4000UL)
#define TIM16_BASE            (APB2PERIPH_BASE + 0x4400UL)
#define TIM17_BASE            (APB2PERIPH_BASE + 0x4800UL)
#define TIM20_BASE            (APB2PERIPH_BASE + 0x5000UL)
#define SAI1_BASE             (APB2PERIPH_BASE + 0x5400UL)
#define SAI1_Block_A_BASE     (SAI1_BASE + 0x0004UL)
#define SAI1_Block_B_BASE     (SAI1_BASE + 0x0024UL)
#define HRTIM1_BASE           (APB2PERIPH_BASE + 0x6800UL)
#define HRTIM1_TIMA_BASE      (HRTIM1_BASE + 0x0080UL)
#define HRTIM1_TIMB_BASE      (HRTIM1_BASE + 0x0100UL)
#define HRTIM1_TIMC_BASE      (HRTIM1_BASE + 0x0180UL)
#define HRTIM1_TIMD_BASE      (HRTIM1_BASE + 0x0200UL)
#define HRTIM1_TIME_BASE      (HRTIM1_BASE + 0x0280UL)
#define HRTIM1_TIMF_BASE      (HRTIM1_BASE + 0x0300UL)
#define HRTIM1_COMMON_BASE    (HRTIM1_BASE + 0x0380UL)

< AHB1 peripherals 
#define DMA1_BASE             (AHB1PERIPH_BASE)
#define DMA2_BASE             (AHB1PERIPH_BASE + 0x0400UL)
#define DMAMUX1_BASE          (AHB1PERIPH_BASE + 0x0800UL)
#define CORDIC_BASE           (AHB1PERIPH_BASE + 0x0C00UL)
#define RCC_BASE              (AHB1PERIPH_BASE + 0x1000UL)
#define FMAC_BASE             (AHB1PERIPH_BASE + 0x1400UL)
#define FLASH_R_BASE          (AHB1PERIPH_BASE + 0x2000UL)
#define CRC_BASE              (AHB1PERIPH_BASE + 0x3000UL)

#define DMA1_Channel1_BASE    (DMA1_BASE + 0x0008UL)
#define DMA1_Channel2_BASE    (DMA1_BASE + 0x001CUL)
#define DMA1_Channel3_BASE    (DMA1_BASE + 0x0030UL)
#define DMA1_Channel4_BASE    (DMA1_BASE + 0x0044UL)
#define DMA1_Channel5_BASE    (DMA1_BASE + 0x0058UL)
#define DMA1_Channel6_BASE    (DMA1_BASE + 0x006CUL)
#define DMA1_Channel7_BASE    (DMA1_BASE + 0x0080UL)
#define DMA1_Channel8_BASE    (DMA1_BASE + 0x0094UL)

#define DMA2_Channel1_BASE    (DMA2_BASE + 0x0008UL)
#define DMA2_Channel2_BASE    (DMA2_BASE + 0x001CUL)
#define DMA2_Channel3_BASE    (DMA2_BASE + 0x0030UL)
#define DMA2_Channel4_BASE    (DMA2_BASE + 0x0044UL)
#define DMA2_Channel5_BASE    (DMA2_BASE + 0x0058UL)
#define DMA2_Channel6_BASE    (DMA2_BASE + 0x006CUL)
#define DMA2_Channel7_BASE    (DMA2_BASE + 0x0080UL)
#define DMA2_Channel8_BASE    (DMA2_BASE + 0x0094UL)

#define DMAMUX1_Channel0_BASE    (DMAMUX1_BASE)
#define DMAMUX1_Channel1_BASE    (DMAMUX1_BASE + 0x0004UL)
#define DMAMUX1_Channel2_BASE    (DMAMUX1_BASE + 0x0008UL)
#define DMAMUX1_Channel3_BASE    (DMAMUX1_BASE + 0x000CUL)
#define DMAMUX1_Channel4_BASE    (DMAMUX1_BASE + 0x0010UL)
#define DMAMUX1_Channel5_BASE    (DMAMUX1_BASE + 0x0014UL)
#define DMAMUX1_Channel6_BASE    (DMAMUX1_BASE + 0x0018UL)
#define DMAMUX1_Channel7_BASE    (DMAMUX1_BASE + 0x001CUL)
#define DMAMUX1_Channel8_BASE    (DMAMUX1_BASE + 0x0020UL)
#define DMAMUX1_Channel9_BASE    (DMAMUX1_BASE + 0x0024UL)
#define DMAMUX1_Channel10_BASE   (DMAMUX1_BASE + 0x0028UL)
#define DMAMUX1_Channel11_BASE   (DMAMUX1_BASE + 0x002CUL)
#define DMAMUX1_Channel12_BASE   (DMAMUX1_BASE + 0x0030UL)
#define DMAMUX1_Channel13_BASE   (DMAMUX1_BASE + 0x0034UL)
#define DMAMUX1_Channel14_BASE   (DMAMUX1_BASE + 0x0038UL)
#define DMAMUX1_Channel15_BASE   (DMAMUX1_BASE + 0x003CUL)
#define DMAMUX1_RequestGenerator0_BASE  (DMAMUX1_BASE + 0x0100UL)
#define DMAMUX1_RequestGenerator1_BASE  (DMAMUX1_BASE + 0x0104UL)
#define DMAMUX1_RequestGenerator2_BASE  (DMAMUX1_BASE + 0x0108UL)
#define DMAMUX1_RequestGenerator3_BASE  (DMAMUX1_BASE + 0x010CUL)

#define DMAMUX1_ChannelStatus_BASE      (DMAMUX1_BASE + 0x0080UL)
#define DMAMUX1_RequestGenStatus_BASE   (DMAMUX1_BASE + 0x0140UL)

< AHB2 peripherals 
#define GPIOA_BASE            (AHB2PERIPH_BASE + 0x0000UL)
#define GPIOB_BASE            (AHB2PERIPH_BASE + 0x0400UL)
#define GPIOC_BASE            (AHB2PERIPH_BASE + 0x0800UL)
#define GPIOD_BASE            (AHB2PERIPH_BASE + 0x0C00UL)
#define GPIOE_BASE            (AHB2PERIPH_BASE + 0x1000UL)
#define GPIOF_BASE            (AHB2PERIPH_BASE + 0x1400UL)
#define GPIOG_BASE            (AHB2PERIPH_BASE + 0x1800UL)

#define ADC1_BASE             (AHB2PERIPH_BASE + 0x08000000UL)
#define ADC2_BASE             (AHB2PERIPH_BASE + 0x08000100UL)
#define ADC12_COMMON_BASE     (AHB2PERIPH_BASE + 0x08000300UL)
#define ADC3_BASE             (AHB2PERIPH_BASE + 0x08000400UL)
#define ADC4_BASE             (AHB2PERIPH_BASE + 0x08000500UL)
#define ADC5_BASE             (AHB2PERIPH_BASE + 0x08000600UL)
#define ADC345_COMMON_BASE    (AHB2PERIPH_BASE + 0x08000700UL)

#define DAC_BASE              (AHB2PERIPH_BASE + 0x08000800UL)
#define DAC1_BASE             (AHB2PERIPH_BASE + 0x08000800UL)
#define DAC2_BASE             (AHB2PERIPH_BASE + 0x08000C00UL)
#define DAC3_BASE             (AHB2PERIPH_BASE + 0x08001000UL)
#define DAC4_BASE             (AHB2PERIPH_BASE + 0x08001400UL)

#define RNG_BASE              (AHB2PERIPH_BASE + 0x08060800UL)
#define DBGMCU_BASE           (0xE0042000UL)
*/

/*  --- NE TOT CPU
  uint32_t HAL_GetREVID(void);
  uint32_t HAL_GetDEVID(void);
  uint32_t HAL_GetUIDw0(void);
  uint32_t HAL_GetUIDw1(void);
  uint32_t HAL_GetUIDw2(void);

  void HAL_SYSCFG_VREFBUF_VoltageScalingConfig(uint32_t VoltageScaling);
  void HAL_SYSCFG_VREFBUF_HighImpedanceConfig(uint32_t Mode);
  void HAL_SYSCFG_VREFBUF_TrimmingConfig(uint32_t TrimmingValue);
  HAL_StatusTypeDef HAL_SYSCFG_EnableVREFBUF(void);
  void HAL_SYSCFG_DisableVREFBUF(void);


  #define SET_BIT(REG, BIT)     ((REG) |= (BIT))
  #define CLEAR_BIT(REG, BIT)   ((REG) &= ~(BIT))
  #define READ_BIT(REG, BIT)    ((REG) & (BIT))
  #define CLEAR_REG(REG)        ((REG) = (0x0))
  #define WRITE_REG(REG, VAL)   ((REG) = (VAL))
  #define READ_REG(REG)         ((REG))
  #define MODIFY_REG(REG, CLEARMASK, SETMASK)  WRITE_REG((REG), (((READ_REG(REG)) & (~(CLEARMASK))) | (SETMASK)))
  #define POSITION_VAL(VAL)     (__CLZ(__RBIT(VAL)))
*/

/*  --- NE TOT CPU
  Reg: 40023800 Value:  0000 0011    0000 0111    0111 1000    1000 0011      (0x03077883)
  Reg: 40023800         0000 0011    0000 0111    0111 1000    1000 0000      (0x03077880)
    
  Bit 25 PLLRDY: Main PLL (PLL) clock ready flag
  Set by hardware to indicate that PLL is locked.
  0: PLL unlocked
  1: PLL locked
  
  Bit 0 HSION: Internal high-speed clock enable

  RCC dedicated clocks configuration register (RCC_DCKCFGR1)
  Address offset: 0x8C
  Reg: 4002388C Value:  0000 0000    0000 0000    0000 0000    0000 0000      (0x00000000)
  Reg: 4002388C         0000 0001    0000 0000    0000 0000    0000 0000      (0x01000000)  
  Bit 24 TIMPRE: Timers clocks prescalers selection
      This bit is set and reset by software to control the clock frequency of all the timers connected
      to APB1 and APB2 domain.
    0:If the APB prescaler (PPRE1, PPRE2 in the RCC_CFGR register) is configured to a
      division factor of 1, TIMxCLK = PCLKx. Otherwise, the timer clock frequencies are set to
      twice to the frequency of the APB domain to which the timers are connected:
      TIMxCLK = 2xPCLKx.
    1:If the APB prescaler (PPRE1, PPRE2 in the RCC_CFGR register) is configured to a
      division factor of 1, 2 or 4, TIMxCLK = HCLK. Otherwise, the timer clock frequencies are set
      to four times to the frequency of the APB domain to which the timers are connected:
      TIMxCLK = 4xPCLKx.
*/
